View Issue Details

IDProjectCategoryView StatusLast Update
0032978Open CASCADEOCCT:Visualizationpublic2022-05-28 15:26
Reporterkgv Assigned Tokgv  
PrioritynormalSeverityminor 
Status verifiedResolutionfixed 
Product Version7.6.0 
Target Version7.7.0 
Summary0032978: Visualization - AIS_ViewController::PickPoint() includes objects invisible in current View
DescriptionAIS_ViewController::PickPoint() doesn't consider View Affinity leading to strange picking results.
Steps To Reproduce
pload MODELING VISUALIZATION
vinit V1/RootView -width 1024 -height 512 -composer 0
vbackground GRAY20

vinit V2/ViewLeft -parent V1/RootView -width 0.5 -height 1.0
vbackground GRAY30

box b 100 200 300
vdisplay -dispMode 1 b
vaspects b -faceBoundaryDraw 1
vfit
vviewcube vc

vinit V2/ViewRight -parent V1/RootView -width 0.5 -height 1.0 -left 0.5
vbackground GRAY40
psphere s 300
#psphere s 1000
vdisplay -dispMode 1 s
vaspects s -material SILVER
vfit
vzbufftrihedron

vactivate V2/ViewLeft
verase s -view
vcamera -rotationMode pick
# rotate by mouse in ViewLeft: KO, camera is rotated around invisible sphere
vseldump selmap1.png -type entity
# OK if sphere is completely removed 
#vremove s
#vseldump selmap2.png -type entity
TagsNo tags attached.
Test case numberv3d/bugs/bug32978

Attached Files

  • image.png (125,532 bytes)
  • selmap_KO.png (5,230 bytes)
  • selmap_OK.png (4,759 bytes)

Relationships

related to 0032976 verifiedkgv Visualization - AIS_InteractiveContext::FitSelected() includes objects invisible in current View 

Activities

kgv

2022-05-21 16:19

developer   ~0108544

image.png (125,532 bytes)

kgv

2022-05-21 16:26

developer   ~0108545

selmap_KO.png (5,230 bytes)
selmap_OK.png (4,759 bytes)

git

2022-05-21 17:24

administrator   ~0108546

Branch CR32978 has been created by kgv.

SHA-1: 88e00942a713203aaf00d0e9532c3213eb481c73


Detailed log of new commits:

Author: kgv
Date: Sat May 21 17:18:43 2022 +0300

    0032978: Visualization - AIS_ViewController::PickPoint() includes objects invisible in current View
    
    SelectMgr_ViewerSelector::TraverseSensitives() now takes into account object's view affinity.
    AIS_InteractiveContext::moveTo() - dropped code SelectMgr_AndOrFilter::SetDisabledObjects()
    as filtering is now done by selector itself.
    
    ViewAffinity property has been moved to PrsMgr_PresentableObject for simplicity.
    Removed redundant map Graphic3d_CView::HiddenObjects().

Author: kgv
Date: Mon May 16 23:02:31 2022 +0300

    0032976: Visualization - AIS_InteractiveContext::FitSelected() includes objects invisible in current View

git

2022-05-21 17:25

administrator   ~0108547

Branch CR32978 has been updated forcibly by kgv.

SHA-1: 86d6c284c2ed2d16fd247643f75476a29eb34492

kgv

2022-05-22 12:04

developer   ~0108549

Patch is ready for review
- OCCT: branch CR32978;
- OCC Products: branch CR32978.

http://jenkins-test-occt/view/CR32978-master-KGV/

osa

2022-05-23 09:48

developer   ~0108551

The patch was reviewed

afokin

2022-05-28 13:06

administrator   ~0108686

Combination -
OCCT branch : IR-2022-05-27
master SHA - 23c56fc66a1823b6e5e58ec3925a490d00eec6bc
e0ceb716c70188b98130b1550914140d0502a6f9
Products branch : IR-2022-05-27 SHA - aa5fde964222c544924ec5189b662b75a13e6bdd
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian80-64:
OCCT
Total CPU difference: 18742.72000000061 / 18677.050000000647 [+0.35%]
Products
Total CPU difference: 11723.460000000106 / 11729.870000000092 [-0.05%]
Windows-64-VC14:
OCCT
Total CPU difference: 20706.5625 / 20665.84375 [+0.20%]
Products
Total CPU difference: 13249.46875 / 13282.171875 [-0.25%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention

git

2022-05-28 15:25

administrator   ~0108698

Branch CR32978 has been deleted by mnt.

SHA-1: 86d6c284c2ed2d16fd247643f75476a29eb34492

Related Changesets

occt: master 86d6c284

2022-05-21 17:18:43

kgv

Details Diff
0032978: Visualization - AIS_ViewController::PickPoint() includes objects invisible in current View

SelectMgr_ViewerSelector::TraverseSensitives() now takes into account object's view affinity.
AIS_InteractiveContext::moveTo() - dropped code SelectMgr_AndOrFilter::SetDisabledObjects()
as filtering is now done by selector itself.

ViewAffinity property has been moved to PrsMgr_PresentableObject for simplicity.
Removed redundant map Graphic3d_CView::HiddenObjects().
Affected Issues
0032978
mod - src/AIS/AIS_InteractiveContext.cxx Diff File
mod - src/AIS/AIS_Manipulator.cxx Diff File
mod - src/AIS/AIS_ViewCube.cxx Diff File
mod - src/Graphic3d/Graphic3d_CView.cxx Diff File
mod - src/Graphic3d/Graphic3d_CView.hxx Diff File
mod - src/Graphic3d/Graphic3d_StructureManager.cxx Diff File
mod - src/Graphic3d/Graphic3d_StructureManager.hxx Diff File
mod - src/IVtkOCC/IVtkOCC_ViewerSelector.cxx Diff File
mod - src/PrsMgr/PrsMgr_PresentableObject.cxx Diff File
mod - src/PrsMgr/PrsMgr_PresentableObject.hxx Diff File
mod - src/PrsMgr/PrsMgr_PresentationManager.cxx Diff File
mod - src/SelectMgr/SelectMgr_ViewerSelector.cxx Diff File
mod - src/SelectMgr/SelectMgr_ViewerSelector.hxx Diff File
add - tests/v3d/bugs/bug32978 Diff File

occt-products: master 93d6f121

2022-05-21 18:51:21

kgv

Details Diff
0032978: Visualization - AIS_ViewController::PickPoint() includes objects invisible in current View Affected Issues
0032978
mod - samples/qt/SSP/src/ViewSSP.cxx Diff File
mod - samples/qt/Unfolding/src/UnfoldingBaseView.cpp Diff File

Issue History

Date Modified Username Field Change
2022-05-17 02:45 kgv New Issue
2022-05-17 02:45 kgv Assigned To => kgv
2022-05-17 02:46 kgv Relationship added related to 0032976
2022-05-21 16:18 kgv Steps to Reproduce Updated
2022-05-21 16:19 kgv Note Added: 0108544
2022-05-21 16:19 kgv File Added: image.png
2022-05-21 16:26 kgv Steps to Reproduce Updated
2022-05-21 16:26 kgv Note Added: 0108545
2022-05-21 16:26 kgv File Added: selmap_KO.png
2022-05-21 16:26 kgv File Added: selmap_OK.png
2022-05-21 17:24 git Note Added: 0108546
2022-05-21 17:25 git Note Added: 0108547
2022-05-22 12:04 kgv Assigned To kgv => osa
2022-05-22 12:04 kgv Status new => resolved
2022-05-22 12:04 kgv Test case number => v3d/bugs/bug32978
2022-05-22 12:04 kgv Note Added: 0108549
2022-05-23 09:48 osa Assigned To osa => bugmaster
2022-05-23 09:48 osa Status resolved => reviewed
2022-05-23 09:48 osa Note Added: 0108551
2022-05-28 13:06 afokin Status reviewed => tested
2022-05-28 13:06 afokin Note Added: 0108686
2022-05-28 14:24 kgv Changeset attached => occt master 86d6c284
2022-05-28 14:24 kgv Assigned To bugmaster => kgv
2022-05-28 14:24 kgv Status tested => verified
2022-05-28 14:24 kgv Resolution open => fixed
2022-05-28 14:24 kgv Changeset attached => occt-products master 93d6f121
2022-05-28 15:25 git Note Added: 0108698